'ebnaut_ifft by df6nm 

'3a 151108 bugfix in riff and fact header
'ebnaut_ifft3.bas 150925
'ebnaut_ifft2.bas 150817
'compiled with FreeBasic: fbc -e ebnaut_ifft3.bas

'requires sr.txt containing 
'audio samplerate, decimation factor, FFT length, RF center frequency

'usage: ebnaut_ifft3 file.txt
'or drag and drop file.txt over program icon

'$ lang: "qb"
#INCLUDE "datetime.bi"
deflng a-z

fname$="fftdata"
cmd$ = ltrim$(rtrim$(command$))
if instr(cmd$,".") > 0 then cmd$ = left$(cmd$,instr(cmd$,".")-1)  
if len(cmd$)>=1 then fname$=cmd$ 

ffttxtfile$=fname$+".txt"
fftbinfile$="fft.dat"
iqfile$=fname$+".wav"

sr1!=12000 '5513.0493!
dec1!=48 '24
dec2!=(2^18)*2
df!=sr1!/dec1!/dec2!
cf#=137500 '137499.982

OPEN "sr.txt" for input as 1
 INPUT #1, sr1!, dec1!, dec2!, cf1#
close #1

sr!=sr1!/dec1!/2
df!=sr1!/dec1!/dec2!
cf#=cf1#

OPEN ffttxtfile$ FOR INPUT AS 1

 INPUT #1, filedate&, filetime#, bw!, startfreq!
 filetime$ = RIGHT$("00000" + LTRIM$(STR$(int(filetime#))), 6)
 filedate$ = RIGHT$("00000000" + LTRIM$(STR$(filedate&)), 8)

 PRINT ffttxtfile$;" ";filedate$; filetime#; df!;cf#;

 ts#=DATESERIAL(val(LEFT$(filedate$, 4)),val(MID$(filedate$, 5, 2)),val(RIGHT$(filedate$, 2))) - DATESERIAL(1970,1,1)
 ts#=ts#*86400
 ts#=ts# + VAL(LEFT$(filetime$,2))*3600 + VAL(MID$(filetime$,3,2))*60 +VAL(RIGHT$(filetime$,2))+ filetime#-int(filetime#) 
 ts#=ts# - .5/df!
 ts# = int(ts#*100+.5)/100
 

 OPEN fftbinfile$ FOR OUTPUT AS 2
 nm&=0
 WHILE NOT EOF(1)
  INPUT #1, ar!, ai!
  PRINT #2, MKS$(ar!); MKS$(ai!);
  nm&=nm&+1
 WEND
 CLOSE 2
CLOSE 1


OPEN fftbinfile$ FOR BINARY AS 1
 
 lmx=4:nmx=16
 while 2*nmx <= nm&
  lmx=lmx+1
  nmx=2*nmx
 wend

 '? nm&;nmx;lmx;
 sr!=df!*nmx
 ? sr!

 nmx1 = nmx - 1: nm21x = 2 * nmx - 1
 DIM ax!(nm21x), wx!(nmx1), nbrx&(nmx1)
 GOSUB calcwx
 GOSUB calcbitrevx

 a$ = INPUT$(8 * nmx, #1)
 FOR n = 0 TO nm21x
  ax!(n) = CVS(MID$(a$, 4 * n + 1, 4))   'centered on nmx/2
 NEXT n

 FOR n = 0 TO nmx-1
  SWAP ax!(n), ax!(n+nmx) '0 Hz to bin 0
 NEXT n

 FOR n = 1 to nm21x-1 step 2
  ax!(n)=-ax!(n) 'conj complex input for inv fft
 NEXT n

 GOSUB fftbasx   'IFFT

 'FOR n = 1 to nm21x-1 step 2
  'ax!(n)=-ax!(n) 'conj complex
 'NEXT n

 OPEN iqfile$ FOR OUTPUT AS 2
 GOSUB wavheader
 PRINT #2,hdr$;
 FOR n = 0 TO nm21x
  PRINT #2, mks$(ax!(n));
 NEXT n
 CLOSE 2

 'GOSUB outfile

end

'_______________________________________
wavheader:

 inf1$="sr="+ltrim$(str$(sr!))+" "
 inf1$=inf1$+"rf="+ltrim$(str$(cf#))+" "
 inf1$=inf1$+"ut=" + ltrim$(str$(ts#))
 inf1$=inf1$+mkl$(0)
 inf1$=left$(inf1$,4*int((len(inf1$)-1)\4)) 
 inf1$="inf1"+mkl$(len(inf1$))+inf1$
 '? inf1$;"*"
 
 fmt$=mki$(-2)+mki$(2)+mkl$(sr!)+mkl$(int(sr!+.5)*8)
 fmt$=fmt$+mki$(8)+mki$(32)+mki$(22)+mki$(32)+mkl$(0)+mkl$(3)
 fmt$=fmt$+mki$(0)+mki$(16)+mki$(128)+mki$(-22016)+mki$(14336)+mki$(29083)
 fmt$="fmt "+mkl$(len(fmt$))+fmt$

 fact$="fact"+mkl$(4)+mkl$(nmx)

 hdr$="WAVE"+fmt$+fact$+inf1$+"data"+mkl$(8*nmx)
 hdr$="RIFF"+mkl$(len(hdr$)+8*nmx)+hdr$  
return

outfile:
 OPEN "out.txt" FOR OUTPUT AS 2
 FOR n = 0 TO nm21x step 2
  PRINT #2, ax!(n);" "; ax!(n+1);" ";
 NEXT n
 CLOSE 2
return
'_______________________________________
'FFT stuff

calcwx:
'nmx/2 warp factors
  sc! = 1
  pi! = 4 * ATN(1)
  FOR n = 0 TO nmx \ 2 - 1
   wx!(2 * n) = sc! * COS(2 * pi! * n / nmx)
   wx!(2 * n + 1) = sc! * -SIN(2 * pi! * n / nmx)
  NEXT n
 RETURN

calcbitrevx:
'bit reversal table
  FOR n = 0 TO nmx - 1
   n2 = 0: n1 = n
   FOR l = 0 TO lmx - 1
    n2 = 2 * n2 + (n1 AND 1)
    n1 = n1 \ 2
   NEXT l
   nbrx&(n) = n2
  NEXT n
 RETURN

'basic fft

fftbasx:
 FOR n = 0 TO nmx - 1
  n2 = nbrx&(n)
  IF n2 < n THEN SWAP ax!(2 * n), ax!(2 * n2): SWAP ax!(2 * n + 1), ax!(2 * n2 + 1)
 NEXT n

 nd = 1: nwd = nmx \ 2
 FOR l = 0 TO lmx - 1
  FOR n0 = 0 TO nmx - 1 STEP 2 * nd
   nw = 0
   FOR n1 = n0 TO n0 + nd - 1
    n2 = n1 + nd
   
    n1r = 2 * n1: n1i = n1r + 1
    n2r = 2 * n2: n2i = n2r + 1
    nwr = 2 * nw: nwi = nwr + 1

    vr! = (ax!(n2r) * wx!(nwr) - ax!(n2i) * wx!(nwi))
    vi! = (ax!(n2i) * wx!(nwr) + ax!(n2r) * wx!(nwi))
    ax!(n2r) = ax!(n1r) - vr!: ax!(n2i) = ax!(n1i) - vi!
    ax!(n1r) = ax!(n1r) + vr!: ax!(n1i) = ax!(n1i) + vi!
    nw = nw + nwd
   NEXT n1
  NEXT n0
  nd = 2 * nd
  nwd = nwd \ 2
 NEXT l
RETURN
