'show_rawsyms3a.bas 
'df6nm 150825...150928
'compiled with FreeBasic:
'fbc -e -s gui show_rawsyms3a.bas

'$LANG: "qb"

defsng a-z

'read symbol data file

open "rawsyms.txt" for input as 1
seek #1,lof(1)-100
in$=input$(95,#1)
nm=val(right$(in$,95-__instrrev(in$,chr$(10))))+1

dim ar(nm-1),ai(nm-1),ph(nm-1)
dim a2r(nm-1),a2i(nm-1),br(nm-1),bi(nm-1),dB(nm-1)

seek #1, 1
for n=0 to nm-1
 input #1,nn,ar(n),ai(n),ph(n) 
next n
close 1


'prepare cos/sin table for dft

dim costab(nm-1),sintab(nm-1)
pi2=8*atn(1)
for n=0 to nm-1
 costab(n)=cos(pi2*n/nm)
 sintab(n)=sin(pi2*n/nm)
next n

'only for testing freq shift and carrier

if 0 then
 dww=0
 dww=-3.141592*2/nm*-.99'+.25
 for n=0 to nm-1
  'ar(n)=ar(n)+2   'offset for testing
  xr=ar(n)*cos(dww*n)-ai(n)*sin(dww*n)
  xi=ar(n)*sin(dww*n)+ai(n)*cos(dww*n)
  ar(n)=xr:ai(n)=xi
 next n
end if

'normalize to average power

psum=0
pmax=0
for n=0 to nm-1
 p=ar(n)*ar(n) + ai(n)*ai(n)
 psum=psum+p
 if p>pmax then pmax=p:nmax=n:?pmax
next n
sqrp=sqr(psum/nm)
for n=0 to nm-1
 ar(n)=ar(n)/sqrp
 ai(n)=ai(n)/sqrp
next n
amax=sqr(pmax)/sqrp

SCREEN 12

'plot phase

VIEW (10,10)-(510,100),,1
WINDOW (0,-180)-(nm-1,180)

for n=-180 to 180 step 90
 line(0,n)-(nm-1,n),1
next n
for n=0 to nm-1 step nm/10
 line(n,-180)-(n,180),1
next n
for n=0 to nm-1
 PSET (n,-ph(n)) 'phase should become more positive if frequency is too high
next n

'plot constellation

VIEW (530,5)-(630,105)
WINDOW (-1.05,-1.05)-(1.05,1.05)
circle (0,0),1,1
for n=0 to nm-1
 PSET (ar(n)/amax,ai(n)/amax)
next n

'plot spectrum

't1=timer
gosub dft
't2=timer:?t2-t1

VIEW (10,120)-(510,240),,1
WINDOW (0,-10)-(nm,50)
for n=-20 to 40 step 10
 line(0,n)-(nm,n),1
next n
for n=0 to nm step nm/10
 line(n,-10)-(n,50),1
next n
col=4
PSET (0,dB(0)),col
for n=1 to nm-1
 LINE -(n,dB(n)),col
next n

VIEW (530,120)-(630,240),,1
WINDOW (-25,-10)-(25,50)
for n=-10 to 50 step 10
 line(-25,n)-(25,n),1
next n
line(0,-10)-(0,50),1
PSET (-25,dB(nm\2-25)),col
for nz=-25 to 25
 LINE -(nz,dB(nm\2+nz)),col
next nz


'plot spectrum of squared symbols

for n=0 to nm-1
 a2r(n)=ar(n)*ar(n)-ai(n)*ai(n)
 a2i(n)=2*ai(n)*ar(n)
next n

for n=0 to nm-1
 swap ar(n),a2r(n)
 swap ai(n),a2i(n)
next n

gosub dft

VIEW (135,260)-(385,380),,1
WINDOW (0,-10)-(nm,50)
for n=-10 to 50 step 10
 line(0,n)-(nm,n),1
next n
for n=0 to nm step nm/10
 line(n,-10)-(n,50),1
next n
col=3
PSET (0,dB(0)),col
for n=1 to nm-1
 LINE -(n,dB(n)),col
next n

VIEW (530,260)-(630,380),,1
WINDOW (-50,-10)-(50,50)
for n=-10 to 50 step 10
 line(-50,n)-(50,n),1
next n
line(0,-10)-(0,50),1
PSET (-50,dB(nm\2-50)),col
for nz=-50 to 50
 LINE -(nz,dB(nm\2+nz)),col
next nz


'evaluate squared spectrum peak

nmax=0:dBmax=-200
for n=1 to nm-1
 if dB(n)>dBmax then dBmax=dB(n):nmax=n 
next n

'quadratic peak interpolation
dBmax=dB(nmax)
fmax=.25
if nmax=0 then fmax=-.25
if nmax>0 and nmax<nm-1 then
 y1=dB(nmax-1):y2=dB(nmax):y3=dB(nmax+1)
 dd=2*y2-y1-y3
 d=0
 if dd<>0 then d = (y3-y1)/(2*dd)
 dBmax = y2 + dd/2*d*d *3  'fudge factor *3
 fmax = ((nmax+d)/nm-.5)/2
end if

'remove freq offset
dw=fmax*8*atn(1)
for n=0 to nm-1
 ar(n)=a2r(n)*cos(dw*n)-a2i(n)*sin(dw*n)
 ai(n)=a2r(n)*sin(dw*n)+a2i(n)*cos(dw*n)
next n

'a3/a2 = autocorrelation with one symbol shift (should be zero if code for prn-like code)
am2r=0:am2i=0:am3r=0:am3i=0
for n=1 to nm-1
 am2r=am2r+ar(n)*ar(n)-ai(n)*ai(n)
 am2i=am2i+2*ar(n)*ai(n)
 am3r=am3r+ar(n)*ar(n-1)-ai(n)*ai(n-1)
 am3i=am3i+ar(n)*ai(n-1)+ai(n)*ar(n-1)
next n
am2=sqr(am2r*am2r+am2i*am2i)/(nm-1)
am3=sqr(am3r*am3r+am3i*am3i)/(nm-1)
am32r=(am3r*am2r+am3i*am2i)/(am2r*am2r+am2i*am2i)

locate 24,1
?nm;" symbols"
?
?using" sqared spectrum peak ##.# dB at frequency #.##### (Hz / symbol duration)";dBmax;fmax
?using" estimated magnitude of time error #.## (symbol durations)";am32r

sleep
END


dft:

sqrnm=sqr(nm)
for nb=0 to nm-1
 sr=0:si=0
 ni=0
 for na=0 to nm-1 
  'wr=cos(w*na):wi=sin(w*na) 'use table instead
  ni=ni+nb: if ni>=nm then ni=ni-nm
  wr=costab(ni):wi=sintab(ni)
  sr=sr+wr*ar(na)-wi*ai(na) 
  si=si+wi*ar(na)+wr*ai(na) 
 next na
 br(nb)=sr/sqrnm:bi(nb)=si/sqrnm
next nb

dB10=10/log(10)
for n=0 to nm-1
 if n<nm\2 then n2=n+nm\2 else n2=n-nm\2
 b2=br(n)*br(n)+bi(n)*bi(n)
 if b2 > 1e-6 then dB(n2)=dB10*log(b2) else dB(n2)=-60
next n

return
